module.exports = function AppController(app){

    function validateApp() {

        var valid = false,
            msg = '';

        var validatedProfile = validateProfile(app.getProfile());

        if (!app.getName()) {

            msg = 'Missing name attribute in package.json.';
        } else if (!app.getVersion()) {

            msg = 'Missing version attribute in package.json.';
            // TODO: UNCOMMENT!!
//        } else if (!validatedProfile.valid) {
//
//            msg = validatedProfile.msg;
        } else {

            valid = true;

            // provide defaults
            if (!app.getTitle()) {
                app.setTitle(app.getName());
            }
            if (!app.getDescription()) {
                app.setDescription(app.getName());
                console.log('Description has been set as: ', app.getDescription());
            }
        }

        return {valid: valid, msg: msg};

        /** HELPER FUNCTION **/
        function validateProfile(profile) {

            var valid = false;

            if (!profile) {

                msg = 'Missing profile in package.json.';
            } else if (
                typeof profile.dml !== 'object' ||
                profile.dml.constructor.toString().indexOf("Array") !== -1)   // TODO: check this logic
            {

                msg = 'profile.dml in package.json is required and must be an object.'
            } else if (!profile.name || typeof profile.name !== 'string') {

                msg = 'profile.name in package.json is required and must be a string.';
            } else {

                valid = true;
            }

            return {valid: valid, msg: msg};
        }

    }

    return {
        validateApp: validateApp
    };
};